// Generated by CoffeeScript 1.10.0
(function() {
  var exec, fs, glob, log, path, ref, run, spawn,
    slice = [].slice;

  ref = require('child_process'), spawn = ref.spawn, exec = ref.exec;

  path = require('path');

  fs = require('fs');

  glob = require('glob');

  log = console.log;

  module.exports = function(task) {
    var baseDir, binDir;
    baseDir = path.resolve(path.join(__dirname, '..'));
    binDir = path.join(baseDir, 'node_modules', '.bin');
    task('build', function() {
      return run("rm -fr ./lib; " + binDir + "/coffee -o lib -c src");
    });
    task('lint', function() {
      var coffeeLintPath;
      coffeeLintPath = path.resolve(path.join(baseDir, 'coffeelint.json'));
      return run(binDir + "/coffeelint -f " + coffeeLintPath + " src/*");
    });
    task('pdf', function() {
      var docsPath, drivePath, fileBaseName, i, len, mdFile, mdFiles, pdfDir, pdfFile, results, version;
      docsPath = (process.cwd()) + "/docs";
      log('glob', docsPath + "/{,**/}*.md");
      mdFiles = glob.sync(docsPath + "/{,**/}*.md", {
        nocase: true
      });
      if (!mdFiles.length) {
        return log('> no files in ./docs');
      }
      version = require(path.join(process.cwd(), 'package.json')).version;
      drivePath = (function() {
        var error;
        try {
          return fs.statSync('./drive') && './drive';
        } catch (error) {

        }
      })();
      results = [];
      for (i = 0, len = mdFiles.length; i < len; i++) {
        mdFile = mdFiles[i];
        pdfDir = path.dirname(mdFile);
        if (drivePath) {
          pdfDir = pdfDir.replace(docsPath, drivePath);
        }
        fileBaseName = path.basename(mdFile, path.extname(mdFile));
        pdfFile = pdfDir + "/" + fileBaseName + "." + version + ".pdf";
        log("creating " + pdfFile + "...");
        results.push(run(binDir + "/markdown-pdf " + mdFile + " -o " + pdfFile, {
          stdio: [process.stdin, process.stdout, 'ignore']
        }));
      }
      return results;
    });
    option('-p', '--path', 'prefix for test files (prefix-string or dir/)');
    return task('test', function(options) {
      var pattern, prefix;
      prefix = options.path || '';
      pattern = "spec/{,**/}" + prefix + "*spec.coffee";
      log("Running tests at " + pattern + "...");
      return run("NODE_ENV=test TZ=GMT " + binDir + "/mocha --compilers coffee:coffee-script/register --reporter spec --colors --recursive '" + pattern + "'");
    });
  };

  run = function() {
    var a, args, callback, cmd, command, i, len, options, params;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    for (i = 0, len = args.length; i < len; i++) {
      a = args[i];
      switch (typeof a) {
        case 'string':
          command = a;
          break;
        case 'object':
          if (a instanceof Array) {
            params = a;
          } else {
            options = a;
          }
          break;
        case 'function':
          callback = a;
      }
    }
    if (options == null) {
      options = {};
    }
    if (options.stdio == null) {
      options.stdio = 'inherit';
    }
    if (params != null) {
      command += " " + params.join + " ";
    }
    cmd = spawn('/bin/sh', ['-c', command], options);
    process.on('SIGHUP', function() {
      return cmd.kill();
    });
    return cmd.on('exit', function(code) {
      return process.exit(code);
    });
  };

}).call(this);
